* =======================================================================================================
* VDIR / Directory of a VDK file
* This dweeb will be loaded by DLOAD this way:
* DLOAD"VDIR"P"DiskName.VDK"   or   DLOAD"VDIR"P"DiskName   (without extension)
* If '.' not found in the name, then .VDK is automatically added 
* The 'P' is a parameter:
*    if not entered, the DIR will be presented as in Dragon
*    if equals 'F', then will show all entries for every file (sectors occupied ...) = FULL
*    Sends packs of 12 text lines to Dragon and waits for the user to press any key to send next block
*    if Break is detected, it stops sending packs, and outputs 'OK' to the screen.
*
* The program will prepare the listing in RAM with this format:
*								Normal	 Full
* FileName  length  8		X			X
* dot       length  1		X			X
* extension length  3		X			X
* protected length  1		X			X
* --------------------
* 1st LSN   lenght  4		-			X
* numSects  length  4		-			X
* BUS       length  4		-			X
* Filelen   length  7		X			X
----------------------
* The rest of the line untill 32 chars is filled with blanks
* In the Full format, the whole name is substituted by spaces from second extent on
*
* =======================================================================================================
       ORG   $2000
       PUT   $2000
*
DNUM   EQU   $12							* assigned drive number by DW4 server
SPEFIL EQU   $13							* special file, has name but no sectors!
SEC1ST EQU   $76							* 1ST directory sector (2 bytes)
FULDAT EQU   $E6							* flag for FULL data (if zero)
PROT   EQU   $E7							* flag for protected file (1)
TABPTR EQU   $F7							* pointer to table entry (2 bytes)
SECAMT EQU   $F9							* number of sectors occupied by a file (2 byte)
NUMCHR EQU   $FB                    * number of bytes to print a number
SECDON EQU   $FC                    * number of directory sectors read
TOTSEC EQU   $FD							* total amount of occupied sectors in the disk (2 bytes)
NOTTAB EQU	 $FF							* flag (0 means send string number to Table, 1 not)
*
DIMASK EQU   $50							* mask to disable interrupts(FIRQ and IRQ)
EIMASK EQU   $AF                    * mask to enable interrupts
NAMBUF EQU   $1D1							* fixed by BASIC, read filename function which stores in $1d1
HEADER EQU   $2F00                  * place where header (sector zero) is to be loaded (2F00-2FFF)
DIRENT EQU   $3000						* where to copy the directory sector containing the entry in process
EXTENT EQU   $3100						* where to copy the directory sector with extensions for the entry in process
TABLE  EQU   $4000                  * Table with all data for each file
*
WAITKY EQU   $8006                  * wait for a key
SYSERR EQU   $8344						* Show error message (B=error code)
OUTSTR EQU   $90E5						* print string at X+1 to DEVNUM
NFAC32 EQU   $9165						* normalize FAC for a 32 bit number
NFAC16 EQU   $9431						* normalize FAC for a 16 bit number
FACSTR EQU   $9587						* convert FAC to ASCII string (pointed by X)
OUTCHR EQU   $B54A					   * print char at reg 'A' to DEVNUM
GETNAM EQU   $B7AA						* read file name and length into $1d1
IOERR  EQU   $B84B						* IO ERROR message
CLS    EQU   $BA77						* clear screen
*											* detect if FULL has been required
ENTRY  JSR   <$A5							* peek at next character (after "VDKDIR")
       SUBA  #'F							* to detect if it was an 'F' - if so show full data
       STA   <FULDAT 					* save difference. 0 = noexec

 		 BEQ   JUMPIT						* if it is 'F', jump it
		 JSR   <$A5							* else get char again
		 CMPA  #'"							* is it a double quote " (beginning of filename)?
		 BEQ   ENT01						* yes, don't jump it
JUMPIT JSR   <$9F							* jump over that char
*											* initial message and save DLOAD vectors
ENT01  BSR   MSG01 					   * print initial message
       LDX   ,S							* get stack pointer ro reg 'X'
       LDU   1,X							* get 1ST address from vector table
       STU   DWRVEC  					* save as vector for DWREAD
       LDU   3,X							* get 2nd address from vector table
       STU   DWWVEC						* save as vector for DWWRITE
       LDU   5,X							* get 3rd address from vector table
       STU   DWDVEC						* save as vector for DWDOREAD
*											* get the name of the VDK
GETN   ORCC  #DIMASK	            	* disable FIRQ, IRQ (to work with DW4)
		 JSR   GETNAM						* read VDK file name and length into $1d1 = nambuf
       LDX   #NAMBUF-1					* byte before packet buffer start
       CLR   ,X							* zero MSB to make a 16 bit value for Y
       LDY   ,X++							* length of file name (16 bit)
       BEQ   FAILED						* if len=0 no file entered
       LDB   -1,X							* length of name (8 bit)
*											* Adding .VDK if not termination entered, costs 31 bytes       
		 PSHS  B,X							* save pointer to beginning of name and name length
ISDOT  LDA   ,X+							* get a char from name
       CMPA  #'.							* is it a dot?
       BEQ   ALRDOT						* yes, stop search, quit loop
       DECB									* decrement counter
       BNE   ISDOT						* not end of string, get next char name
       LDD   #$2E56						* get chars ".V"
       STD   ,X++							* add to end of name
       LDD   #$444B						* get chars "DK"
       STD   ,X++							* add to end of name
		 LDB   ,S							* get old name length
		 ADDB  #4							* add 4 (because of .VDK added)
		 STB   ,S							* update new length in stack
       STB   NAMBUF						* save new length in byte before string
       LEAY  4,Y                    * correction to name length - DW parameter
ALRDOT PULS  B,X       					* restore pointer and length
		 CLR   B,X							* zero terminate name string (for error)
       INC   ,--X							* 1 = DriveWire OP_NAMEOBJ_MOUNT command
       LEAY  2,Y							* length of DW packet = name length + 2
       JSR   (DWWVEC)					* send file request to server
       LDX   #DNUM						* our drive number variable
       CLR   ,X							* clear it
       LEAY  1,Y							* read one byte back
       JSR   (DWRVEC)					* get drive number
       TST   ,X							* verify received value
       BNE   VDHEAD						* successful mount                                       
       LDB   #$19							* code for MO ERROR
		 ANDCC #EIMASK						* enable interrupts
		 JMP   SYSERR						* show error message
*											* Messages Dispatcher
MSG05  LEAS	 6,S                    * to get rid of X,U,PC put in stack by MOREXT
		 LDX   #BADVDK-1              * point to message "Bad VDK directory"
		 FCB   #$10							* forms LDY #xxxx with next instruction, to jump it
MSG04  LDX   #NOTDW-1					* point to error message "Not DW-adapted file"
		 FCB   #$10							* forms LDY #xxxx with next instruction, to jump it
MSG03  LDX   #NOTVDK-1					* point to error message "Not VDK file"  
    	 ANDCC #EIMASK						* enable interrupts
  		 FCB   #$10							* forms LDY #xxxx with next instruction, to jump it
MSG01  LDX   #LDTEXT-1					* point to intro message
       JSR   OUTSTR						* print message to screen
		 RTS									* return
*
FAILED ANDCC #EIMASK						* enable interrupts
		 JMP   IOERR						* I/O error message
*											* Read and verify VDK header
VDHEAD LDX   #0							* first data sector to be read through DW4
		 STX	 <TOTSEC						* no used sectors
       LDY   #HEADER						* point to header read area
       JSR   (DWDVEC)					* read header
       BCS   FAILED						* detect frame error
       BNE   FAILED						* detect incomplete read operation
       LDD   #$646B                 * first word (byte numbers 0-1) should be 'dk' (lowercase)
       CMPD  ,Y                     * is a VDK file?
       BNE   MSG03				      * no, show error (Not an VDK file)
		 LDB   2,Y  						* header length. Low 8 bits come in byte 2
		 LDA   3,Y                    * header length. High 8 bits come in byte 3
		 CMPD	 #$0100						* is it a DW-adapted VDK?
       BNE   MSG04						* no, show error (Not DW-adapted VDK)
*											* Get geometry parameters of the VDK
VDK    LDX   #361							* 1st directoy sector for a 180k disk
		 LDB   9,Y							* byte number 9 is number of sides (1=single for 180K - 2=double for 360k and 720k upon byte 8)
		 CMPB  #2							* is double sided?
		 BNE   NOTX2						* no, don't double tracks
		 LDX	 #721							* 1st directory sector for double sided disks
NOTX2	 LEAX  2,X							* jump over the two FAT sectors
		 STX   <SEC1ST						* save number of 1st directory data entry sector

****************************************************************************************************
* directory entries process
****************************************************************************************************
		 LDB   #4							* minimum value
		 STB   <NUMCHR						* for number width (in chars)
		 CLR   <SECDON						* zero dir sectors read
		 CLR   <NOTTAB						* numbers to Table
		 LDX   #TABLE						* get beginning of the table at RAM
		 STX   <TABPTR						* save at working variable
		 LDX   <SEC1ST                * get first data directory sector (track 20 sector 3)
*                             	* For each data directory sector (from SEC1ST to SEC1ST+15 = 3 to 18)
NXTSEC LDY   #DIRENT						* point to directory entries area in RAM
       JSR   (DWDVEC)					* read directory sector
       BCS   FAILED						* detect frame error
       BNE   FAILED						* detect incomplete read operation
*											* For each one of its 10 entries
       LDU   #DIRENT						* point to read data area
NENT01 CLR   <SECAMT		 				* zero sectors used
		 CLR   <SECAMT+1					* 2 bytes counter
       CLR   <SPEFIL		 				* no special file
		 LDA   ,U							* Read flags of this entry
       BITA  #8							* if Flags AND 8 = 8 then END of Directory reached. Get out of both FOR's
       LBNE  MNTLIN						* if so, go to mount lines
       BITA  #128+1                	* if Flags AND 1 = 1 this is an Extension, don't use it and go to next entry
       										* if Flags AND 128 = 128 then is a Deleted File, forget about it and go to next entry
       LBNE  NXTENT						* if any of them go to next entry
*											* Got a valid file entry, put info into Table creating a record for every extent!
       CLR   <PROT						* not protected file
       BITA  #2                     * if Flags AND 2 = 2 this file is Protected
       BEQ   EXT01						* if not, jump over next one
       INC   <PROT						* mark as protected
EXT01  TST   14,U							* is offset 14 zero (num sectors for 1st extent)?   
*                                * Added control to detect special files, costs 26 bytes and a low ram variable
		 BNE	 EXT01A						* sectors used, process entry   
       INC   <SPEFIL						* mark it as  special file (has name but no sectors!)
EXT01A LDD   #$0108						* Offset 1-8 = FileName
    	 LBSR  ADDTAS						* put name into table
       LDA   #'.							* get dot ascii code
       STA   ,X+							* add to table
       STX   <TABPTR						* update pointer
		 LDD   #$0903						* Offset 9-11 = Extension
	 	 LBSR  ADDTAS						* add to table
		 LDA   #32							* get space ascii code
		 TST   <PROT						* is this protected file?
		 BEQ   EXT01B						* no, jump next one
		 LDA   #'p							* get lowercase 'p' ascii code
EXT01B STA   ,X+							* put byte into table
       STX   <TABPTR						* update pointer
       TST   <SPEFIL						* is this a special file?
       BEQ   NORMAL						* no, normal process
		 LDD   #$2006						* A=space ASCII code - B=6 spaces to add to fill record
       TST   <FULDAT						* full data required?
       BNE   FILSPA						* no, show sapces
		 ADDB  #$0C							* + 12 spaces if Full data required
FILSPA BSR   PUTSPA						* fill table with these spaces
		 LDA   #'0							* get 0 ascii code
 		 STA   ,X+							* add it as length of file into table
   	 TST   <FULDAT						* should show full data?
		 BEQ   NOMORE						* yes,no need to add more spaces
       LDB   #12							* extra spaces to be added
       BSR   PUTSPA						* fill table with these spaces
NOMORE STX   <TABPTR					* save pointer
		 BRA   NXTENT						* go to next file entry       
       									* used sectors process for the 4 extents
NORMAL LDB   #14							* offset to number of sectors for 1st extent
EXTLOP PSHS  B       					* save value
       CLRA									* zero high byte
       LDB   B,U   						* get number of sectors
	    ADDD  <SECAMT						* add the used sectors by this file until now
	    STD   <SECAMT						* update counter
		 TST   <FULDAT						* full data requested?
		 BNE	 EXT01C 						* no, don't add it to Table
		 LDB   ,S							* get offset to number of sectors
		 SUBB  #2							* gives offset to 1st sector LSN
       LDD   B,U                 	* get LSN of this extent
	 	 LBSR  NUM16B						* convert number to string and add to Table
       CLRA									* zero high byte
       LDB   ,S							* get offset to number of sectors
       LDB   B,U   						* get number of sectors
		 LBSR  NUM16B						* convert number to string and add to Table
EXT01C PULS  B								* get offset to number of sectors cleaning stack
		 ADDB  #3							* gives offset to number of sectors for next extent
		 CMPB  #23							* is it out of limit?
		 BHI   EXT04A						* yes, out of this loop
		 TST   B,U         				* is number of sectors for next extent equal to zero?
       BNE   EXT02						* no, process next extent
       LBSR  ADDLL				      * yes, so no more extents, add bytes in last sector & length of file to Table
       BRA   NXTENT						* go to next file entry
EXT02  LBSR  CPYNAM		 				* fill previous entry and initial part of new one with spaces
		 BRA   EXTLOP						* back to process this entry
		 									* see if there are more extents to analyze
EXT04A LDA	 ,U							* get Flags of this entry
       BITA  #32							* if Flags AND 32 = 32 there are more extents
       BEQ   EXT04B                 * else fill record and go to next file entry
 		 LBSR	 MOREXT 						* CALL MoreExtents(Offset 24)
		 BRA   NXTENT						* go to next file entry
EXT04B LBSR  ADDLL				      * no more extents, so add bytes in last sector & length of file
*
NXTENT LDY   <TOTSEC					   * get total sectors used in disk
 		 LDD	 <SECAMT						* get sectors used by the last file
 		 LEAY  D,Y							* add to disk total
 		 STY   <TOTSEC						* update accumulator
		 LEAU  25,U				 			* point to next entry - (step 25 bytes)
       CMPU  #DIRENT+250				* detected end of entries?
       LBLO  NENT01						* no, process next file entry
       INC   <SECDON						* increment number of dir sectors processed
       LDB   <SECDON						* get this value
       CMPB  #16                    * finished whole directory? (from 3 to 18, so 16 data sectors)
       BHS   MNTLIN						* yes, show dir
		 LDX   <SEC1ST		 				* get first directory sector
		 ABX									* add procesed ones
       LBRA	 NXTSEC						* process next directory sector
*       
******************************************************************************
* needs number of spaces at B - X must point to Table
******************************************************************************
PUTSPA PSHS	 A								* save register
		 LDA	 #32							* get space ascii code
PUT01	 STA	 ,X+							* send to screen
		 DECB									* decrement counter
		 BNE   PUT01						* if not all sent, keep on
		 PULS  A,PC							* restore register and return
******************************************************************************		 
*       
MNTLIN LDX	 <TABPTR						* get pointer to table
		 LDA   #$FF 						* get EOData flag
		 STA	 ,X							* put EndOfData flag
		 LDX	 #TABLE						* get beginning of table
		 STX   <TABPTR						* put at table pointer
NXTBLK JSR   CLS						   * clear screen
       TST   <FULDAT						* show columns header upon Full or Not
		 BEQ   FULHDR						* if full jump over next two
		 LDX   #TXTHDN-1					* get normal header
		 FCB   #$10							* forms LDY nnnn, to jump over next one
FULHDR LDX	 #TXTHDF-1              * get full header
MNT01	 JSR   OUTSTR						* put header on first row
		 LDX	 <TABPTR						* get table pointer
		 LDU	 #384							* show max. 12 lines from Table, a total of 12*32 BYTES ($180)
MNT02	 LDA	 ,X+							* get a byte from Table
		 CMPA  #$FF							* is it the EndOfData flag?
		 BEQ   EMNTL						* yes, end outputing lines
		 JSR   OUTCHR						* send char to screen
		 LEAU  -1,U							* decrement counter
		 CMPU  #0							* printed all 12 lines?
		 BNE   MNT02						* no, keep on
		 STX   <TABPTR						* save pointer
		 LDA   ,X						   * get next byte
		 CMPA  #$FF						   * is the EndOfData flag?
		 BEQ   EMNTL					   * yes, add free bytes line
MNT03  JSR   WAITKY						* is a key pressed?
       BEQ   MNT03						* wait for a key
       CMPA  #3							* is Break code?
       BEQ	 EMNTS						* yes, quit outputing lines
       BRA   NXTBLK				   	* next block of 12 lines
EMNTL  LDY   #HEADER                * point to beginning of VDK header
		 LDD   8,Y							* b8 is numtracks (40=for 180 & 360K - 80=for 720k)  -  b9 is sides (1-2)
		 CMPB  #2							* is double sided?
		 BNE   MNT04						* no, don't double tracks
		 ASLA									* A = total number of tracks of the disk (both sides) (40 - 80 - 80 - 160)
MNT04	 SUBA  #2							* must deduct dir and dir backup (2 sectors)
		 LDB	 #18                    * number of sectors per track and side
		 MUL									* calculate total number of sectors (720 - 1440 - 1440 - 2880)
       TFR   D,Y							* Y gets num sectors of full disk
		 LDD   <TOTSEC	 					* get sectors occupied
		 NEGB									* convert B to negative
		 ADCA  #0							* affect borrow to A (if B had been zero)
		 NEGA									* convert A to negative, now D = - old D
		 LEAY  D,Y							* equals Y = Y - D
		 LDB   #7							* max len for free bytes on screen
		 STB   <NUMCHR		 				* save value to variable
		 CLRB									* as lower byte. Multiplies Y (sectors) by 256 giving bytes
		 INC	 <NOTTAB						* string must not be added to the Table
		 BSR	 NUM24B						* convert free bytes into a String
	 	 TFR   D,X							* now X points to the String containing the free bytes number
   	 JSR   OUTSTR						* show free bytes
		 LDX   #MBYTES-1				   * send text " FREE BYTES" 
		 FCB   #$10							* convert next one into LDY #nnnn , to jump over it
EMNTS	 LDX   MBREAK-1					* point to "BREAK" message
		 JSR   OUTSTR						* show message
    	 ANDCC #EIMASK						* enable interrupts
       RTS									* end DIR dweeb, go back to the caller

*********************************************************************
* Adds bytes in last sector and file length into Table
*********************************************************************
ADDLL  TST   <FULDAT						* full data requested?
		 BNE   ADL02						* no, jump last sector bytes
		 CLRA						 			* high byte to cero
		 LDB   24,U                   * get numbytes of last sector
       BNE   ADL01						* if not zero, put into table
       INCA									* zero equals 256 bytes!
ADL01  BSR	 NUM16B						* convert num into string and put into Table
ADL02	 LDB   #7							* number of chars
	    STB   <NUMCHR						* to print file length
		 CLRB									* zero last sector's bytes
		 LDY   <SECAMT						* get number of sectors used (16 bits)
		 TST   24,U					      * bytes in last sector
		 BEQ   ADL03						* if 0 equals 256, so no mods needed
		 LEAY  -1,Y							* last sector has numbytes, so discount it
		 LDB   24,U							* get last sector's bytes
ADL03	 BSR   NUM24B						* convert 24 bits into a String and put into Table
		 TST   <FULDAT						* full data requested?
		 BEQ   ADL05						* yes, no need to pad line
		 LDD   #$200C						* A = space ASCII code - B = 12 spaces to be added
ADL04  STA   ,X+							* put char
		 DECB									* decrement counter
		 BNE   ADL04						* if not all, keep on
		 STX   <TABPTR						* save table pointer
ADL05	 RTS									* return

*************************************************************************
* fills end of previous (not FULL Dir) entry with 11 spaces
* and copies 13 chars of name from previous table entry (same file)
*************************************************************************
CPYNAM TST   <FULDAT						* full data requested?
		 BNE   CPY03						* no, don't do anything
		 PSHS  B								* to preserve register
		 LDB   #$18							* add 11 spaces to fill actual record till len=32 + 13 for filename space in next record
		 LBSR  PUTSPA						* add these spaces to table
       STX   <TABPTR						* update pointer
       PULS  B								* get register back
CPY03	 RTS									* return

*********************************************************************
* Adds a string into Table. If requested, converts nulls into spaces 
* Parameters: U = pointer to beginning of Sector Entry
*             A = offset of data to copy
*             B = number of bytes to be copied
* Registers affected: X (returns Tabpointer)
*********************************************************************
ADDTAS PSHS  U								* save pointer
		 LDX	 <TABPTR						* pointer to table entry
	    LEAU  A,U							* point to data from sector entry plus offset
ADD01  LDA   ,U+							* get a byte
		 BNE   ADD02						* if not null, save data
       LDA   #32							* get a space ascii code instead
ADD02  STA   ,X+							* put in table
	    DECB									* decrement counter
	    BNE   ADD01						* not all done, keep on
	    STX   <TABPTR						* update pointer
	    PULS  U,PC							* return

*************************************************************************
* Puts a 16bits value to the FAC and converts into a String
* Param: D = 16 bit Number
* Return the pointer to the String at reg X
*************************************************************************
NUM16B PSHS  X,Y,U		 				* save registers
		 STD   $50							* put number into FAC higher bytes
		 LDB   #$90 						* exponent for a 16 bit number
		 COMA									* C=1, flag for positive number
		 JSR   NFAC16						* normalize FAC for a 16 bit number
		 BRA   NUM24E						* go to rest of the process

*************************************************************************
* Puts a 24bits value to the FAC and converts into a String 
* Params: Y = 16 higher bits   -  B = lower byte
* Return the pointer to the String at reg X
*************************************************************************
NUM24B PSHS  X,Y,U		 				* save registers
		 CLRA									* zero
		 STA   <$50							* clear 1st mantissa byte
		 STY   <$51							* puts 2nd and 3rd bytes
		 STB   <$53							* puts lower byte
		 STA   <$54							* clear mantissa sign
		 STA   <$63							* clear rounding byte
		 LDA   #$A0							* exponent for a 32 bit number
		 STA   <$4F							* save it
		 JSR   NFAC32						* normalize FAC for a 32 bit number
NUM24E JSR   FACSTR						* convert FAC to ASCII (pointed by X)

*************************************************************************
* Stores the FAC as a string into Table left padded with spaces
* Or returns the String address in register D
*************************************************************************
ADDNUM TST   <NOTTAB						* should data be put into Table
		 BNE	 NOTADD						* don't add data
		 LEAY  ,X							* Y points to string
		 CLRB									* counter to zero
CNV01  LDA	 ,X+							* get a char
		 BEQ   CNV02						* if null, end of string
		 DECB									* increment counter (negative counter)
		 BRA   CNV01						* get next char
CNV02  ADDB  <NUMCHR						* add minimum chars (4 or 7). Result is number of spaces to add
		 PULS  X								* X points to next table position
		 TSTB									* is B zero?
		 BEQ   CNV04						* don't add spaces
       LBSR  PUTSPA						* add these spaces to table
CNV04  LDA   ,Y+							* get first digit
		 BEQ   CNV05						* if null, end
		 STA   ,X+							* put on table
		 BRA   CNV04						* next digit
CNV05  STX   <TABPTR						* update pointer
		 LDB   #4							* restore 4 as
		 STB   <NUMCHR						* min len for a number
		 PULS  Y,U,PC						* return
NOTADD CLR   <NOTTAB						* flag back to value "send to Table"	
		 TFR   X,D							* to return the String address in D
		 PULS  X,Y,U,PC					* restore all registers and return

*************************************************************************************
* Process for exta extents (additional ones)
*************************************************************************************
MOREXT PSHS  X,U							* save pointers (Table & DataEntry)
NXTMOR LDA   24,U							* get offset 24 as input (next entry to use)
		 CLRB      							* first directory sector
MOR01  SUBA  #10							* subtract 10 entries (1 sector)
		 BMI   MOR02						* if negative value, adapt result
		 INCB									* increment sector number
		 BRA   MOR01						* keep on subtracting
MOR02	 ADDA  #10							* to get a positive value = entry number where the extents begin	 
       LDU   #EXTENT						* point to beginning of read data area for extents
		 LDX   <SEC1ST						* get first directory sector
		 ABX									* add calculated sector
		 LDB   #25							* entry length
		 MUL									* space to jump over (A was entry to find in the calculated sector)
		 LEAU  D,U							* U points to first byte of desired extents entry (in buffer area)
		 LDY   #EXTENT						* point to extent entries area in RAM
       JSR   (DWDVEC)					* read directory sector
       BCS   MFAIL						* detect frame error
       BNE   MFAIL						* detect incomplete read operation
		 LDA   ,U							* get entry flags (fisrt byte of entry)										
       BITA	 #1							* Flags (offset 0) AND 1 must be equal to 1 (extent entry)
       LBEQ  MSG05						* else we have a problem and must quit program
                              	* For each of the 7 extents in this entry
       LDB   #3							* offset to number of sectors for 1st extent
       PULS  X								* get Table pointer back
MOR03  LDA   B,U 							* is number of sectors = 0?
       BEQ   MOR05						* yes, finalize record and return
       PSHS  A,B							* to preserve regs A, B 
       CLRA									* zero high byte
       LDB   ,S+							* get number of sectors and move stack pointer
	    ADDD  <SECAMT						* add the used until now
	    STD   <SECAMT						* update counter
	    PULS  B								* get offset back, cleaning stack
		 TST   <FULDAT						* shoud give details?
		 BNE	 MOR04   					* no, skip saving them
     	 PSHS	 B								* save B (offset to number of sectors)
       LBSR	 CPYNAM		 				* fill previous entry and copy initial part of new one
       LDB   ,S							* get offset back
		 SUBB  #2							* to point to offset 1st LSN
 		 LDD   B,U							* gets the 1st LSN ot the extent
		 LBSR  NUM16B						* convert number into string and add into Table
       CLRA									* to have 16 bits number
		 LDB   ,S							* point to number of sectors offset
       LDB   B,U   						* get number of sectors
		 LBSR  NUM16B						* convert number into string and add into Table
		 PULS  B								* get offset to number of sectors, cleaning stack
MOR04	 ADDB  #3							* point to next extent - (step 3 bytes)
		 CMPB  #22							* out of range?
		 BLO   MOR03						* no, process next extent
 		 LDA   ,U							* get entry flags
 		 BITA  #32							* entry flags AND 32 = 32? 
		 BNE   NXTMOR						* yes, there are more extents, go process them
MOR05  LBSR  ADDLL				      * no more extents, so add bytes in last sector & length of file
       PULS  U,PC						   * get pointer to beginning of entry back and return
MFAIL  LEAS  6,S  						* clean stack
	 	 ANDCC #EIMASK						* enable interrupts
		 JMP   IOERR						* I/O error message
*
LDTEXT FCC   /DIRECTORY /
       FCC   /PRINT/,13,0				* intro message to the user
NOTVDK FCC   /NOT AN VDK FILE/,0		* bad VDK file
NOTDW  FCC   /VDK NOT FOR DW/,0		* VDK not adapted for DW
BADVDK FCC   /BAD VDK /
		 FCC   /DIRECTORY/,0  			* Bad directory entry
TXTHDF FCC	 /  FILENAME   /
		 FCC   /1LSN  N. LSB /
		 FCC   / BYTES/,0					* Header for full Dir
TXTHDN FCC   /  FILENAME   /
		 FCC   /  BYTES/,13,0			* Header for normal Dir
MBYTES FCC	 / FREE BYTES/,13,0		* Free bytes message
MBREAK FCC	 /BREAK/,13,0				* Break message
*
DWRVEC FDB   0								* indirect jump to drivewire read function
DWWVEC FDB   0								* indirect jump to drivewire write function 
DWDVEC FDB   0								* indirect jump to drivewire doread function
* 
